/**
 * Elaaden Vault
 *
 * ~$ spin -search -bfs elaaden_vault.pml        # sequence is E(3), E(4)
 *
 * author: Patrick Trentin <patrick.trentin@unitn.it>
 *
 */

#define OFF 0
#define ON  1

chan ps[5] = [0] of { bit };
bit  state[5] = { OFF, ON, OFF, ON, ON };

#define gate_is_open (state[0] & state[1] & state[2] & state[3] & state[4])

proctype ControlPillar(byte id; chan ctl)
{
    bit in;
    do
        :: atomic { ctl?in ->
            state[(id - 1 + 5) % 5] = ! state[(id - 1 + 5) % 5];
            state[id]               = ! state[id];
            state[(id + 1) % 5]     = ! state[(id + 1) % 5];
           }
        :: gate_is_open -> break;
    od
}

active proctype Commander()
{
    byte id;
    do
        :: !gate_is_open ->
            select(id:  0 .. 4);
            printf("E (%d)\n", id);
            ps[id]!1;
        :: else ->
           printf("Walk in..\n"); break;
    od;
}

init
{
    run ControlPillar(0, ps[0]); run ControlPillar(1, ps[1]);
    run ControlPillar(2, ps[2]); run ControlPillar(3, ps[3]);
    run ControlPillar(4, ps[4]);
}

ltl p1 { [] ! gate_is_open }
