/**
 * Smokers
 *
 * author: Patrick Trentin <patrick.trentin@unitn.it>
 *
 */

#define TOBACCO 1
#define PAPER   2
#define MATCHES 4

unsigned table : 3 = 0;

inline smoke()
{
    if
      :: id & TOBACCO -> printf("Tobacco Smokes\n");
      :: id & PAPER   -> printf("Paper Smokes\n");
      :: id & MATCHES -> printf("Matches Smokes\n");
    fi
    table = 0;
};

proctype smoker(mtype id; chan master)
{
  do
    :: atomic {
        master?eval(id) ->                            assert(~(id & table));
        table = (table|id);                           assert(id&table);
       }
    :: table == ((TOBACCO|PAPER|MATCHES) & ~id) ->
        smoke();                                      assert(~table);
  od
}

init
{
  unsigned i : 2 = 0; unsigned j : 2 = 0;
  chan master = [0] of { mtype };

  run smoker(TOBACCO, master);
  run smoker(PAPER, master);
  run smoker(MATCHES, master);

  do
    :: table == 0 ->
        select(i: 0..2); select(j: 0..2);

        if
          :: i == j -> j = (j + 1) % 3;
          :: i == j -> j = (j + 2) % 3;
          :: else -> skip;
        fi;

        master!(1<<i); master!(1<<j);
  od;
}

